#!/usr/bin/perl
#
# Ultimate Bulletin Board is copyright Infopop Corporation, 1998-2000.
#
#       ------------ ubbmail.cgi -------------
#
#
#  Infopop Corporation offers no
#  warranties on this script.  The owner/licensee of the script is
#  solely responsible for any problems caused by installation of
#  the script or use of the script, including messages that may be
#  posted on the BB.
#
#  All copyright notices regarding the Ultimate Bulletin Board
#  must remain intact on the scripts and in the HTML
#  for the scripts.
#
# For more info on the Ultimate BB, 
# see http://www.UltimateBB.com
#
###############################################################
#
#If you are running UBB on IIS,
#you may need to add the following line
#if so, just remove the "#" sign before the print line below
#print "HTTP/1.0 200 OK\n";

eval {

  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file

require "UltBB.setup";
require "Date.pl";
require "mail-lib.pl";
require "Styles.file";
require "ubb_library.pl";
require "ubb_library2.pl";
require "mods.file";
};

if ($@) {
	print ("Content-type: text/html\n\n");
        print "Fehler beim Aufruf der Datei(en): $@\n";
        print "Stellen Sie sicher, da&szlig; diese Datei(en) vorhanden ist/sind, die Zugriffsrechte und Systempfade korrekt eingestellt sind.";
 exit;
}

use Socket;

&ReadParse;

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	
		if ($Name eq "forum") {
			$Forum = $Value;
			$Forum =~ s/\/\\//g;
			$ForumCoded = &HTMLIFY($Forum);
			$ForumCoded =~ tr/ /+/;
			$Forum = &UNHTMLIFY($Forum);
		}
		if ($Name eq "Subject") {
			$Subject = $Value;
			$Subject =~ s/<.+?>//g;
		}
		if ($Name eq "UserName") {
			$UserName = $Value;
			$UserName = &UNHTMLIFY($UserName);
			$UserNameCoded = &HTMLIFY($UserName);
			$UserNameCoded =~ tr/ /+/;
		}
		if ($Name eq "Password") {
			$Password = $Value;
			$Password = &UNHTMLIFY($Password);
			$PasswordCoded = &HTMLIFY($Password);
			$PasswordCoded =~ tr/ /+/;
			
		}
}  # end FOREACH $row

print ("Content-type: text/html\n\n");


if ($VariablesPath eq "") {
	$VariablesPath = $CGIPath;
}

#create random numbers for headers/footers
$RandomNumber = &MakeRandomNumber;
$RandomNumber2 = $RandomNumber + 100074;

if ($Header ne "") {
$Header =~ s/UBBrandomX/$RandomNumber/isg;
$Header =~ s/UBBrandomY/$RandomNumber2/isg;
}
if ($Footer ne "") {
$Footer =~ s/UBBrandomX/$RandomNumber/isg;
$Footer =~ s/UBBrandomY/$RandomNumber2/isg;
}


#adjust bgcolor variables
if ($BGColor ne ""){
$BGColor = qq(bgcolor="$BGColor");
}
if ($AltColumnColor1 ne ""){
$AltColumnColor1 = qq(bgcolor="$AltColumnColor1");
}
if ($AltColumnColor2 ne ""){
$AltColumnColor2 = qq(bgcolor="$AltColumnColor2");
}
if ($CategoryStripColor ne ""){
$CategoryStripColor = qq(bgcolor="$CategoryStripColor");
}
if ($TableColorStrip ne ""){
$TableColorStrip = qq(bgcolor="$TableColorStrip");
}
if ($PageBackground ne ""){
$PageBackground = qq(background="$NonCGIURL/$PageBackground");
}

if ($TableBorderColor ne ""){
$TableWidth2 = "100%";
$BorderTop = qq(<table border=0 cellpadding=0 cellspacing=0 width="$TableWidth"><TR><td bgcolor="$TableBorderColor">);
$BorderBottom = qq(</td></tr></table> );
}  else {
$TableWidth2 = $TableWidth;
$BorderTop = "";
$BorderBottom = "";
}

if ($in{'action'} eq "subscribesubmit") {
 &SubscribeSubmit;
 } 

if ($in{'action'} eq "unsubscribe") {
 &Unsubscribe;
 } 
if ($in{'action'} eq "adddigest") {
 &AddDigest;
 } 
if ($in{'action'} eq "mailusers") {
 &MailUsers;
 } 
 
if ($in{'action'} eq "subscribe") {
 &Subscribe;
 } 
 
if ($in{'action'} eq "sendthedigest") {
 &SendTheDigest;
 exit;
 } 
if ($in{'action'} eq "subscriberedit") {
 &SubscriberEdit;
 exit;
 } 
if ($in{'action'} eq "deletedigest") {
 &DeleteTheDigest;
 exit;
 } 
 
if ($in{'action'} eq "subscribelistemail") {
 &SubscribeListEmail;
 exit;
 } 
if ($in{'action'} eq "subscribelistintro") {
 &SubscribeListIntro;
 } 
if ($in{'action'} eq "digeststart") {
 &DigestStart;
 } 
 
sub MailUsers {

if ($in{'createlist'} eq "yes") {
&CreateList;
exit;
}

if ($in{'start'} eq "0") {

if ( ($in{'UserName'} eq "") || ($in{'Password'} eq "") || ($in{'Subject'} eq "") || ($in{'Message'} eq "") ) {
 &StandardHTMLCP("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es noch einmal!");
exit;
}

}  else {

if ( ($in{'UserName'} eq "") || ($in{'Password'} eq "")) {
 &StandardHTMLCP("Es gibt ein Problem mit Ihrem Benutzernamen, die eMail-Funktionen k&ouml;nnen nicht ausgef&uuml;hrt werden.");
exit;
}
}

&VerifyAdmin($UserName, $Password);

if ($Proceed ne "true") {
	exit;
}

if ($UseEmail eq "ON") {
#then continue
	$subject = $Subject;
	$message = $in{'Message'};
	$message =~ s/<BR>/\n/ig;
	$message =~ s/<P>/\n\r\n/ig;
	$message =~ s/<.+?>//g;
	$Message = &ConvertReturns("$message");
	
if ($in{'start'} eq "0") {
	$subject = $Subject;
	$message = $in{'Message'};
	$message =~ s/<BR>/\n/ig;
	$message =~ s/<P>/\n\r\n/ig;
	$message =~ s/<.+?>//g;
	$Message = &ConvertReturns("$message");
	
#print to file for record-keeping
unless (-e "$NonCGIPath/emaillog") {
mkdir ("$NonCGIPath/emaillog", 0777);
chmod(0777, "$NonCGIPath/emaillog");
}

&GetDateTime;
$EmailNumber = "$RunonDate$JSTime$sec";

open (EMAILLOG, ">$NonCGIPath/emaillog/$EmailNumber.cgi"); 
print EMAILLOG "$subject\n";
print EMAILLOG "$Message\n";
close (EMAILLOG);
chmod(0666, "$NonCGIPath/emaillog/$EmailNumber.cgi");

#print emaillist to file
&GetEmails;
foreach $thisline(@EmailList) {
chomp($thisline);
	($sendto, $profnum) = split(/\?\?/, $thisline);
	@profilestats = &OpenProfile("$profnum.cgi");
	$AllowMassMail = $profilestats[14];
	chomp($AllowMassMail);
	
	if ($AllowMassMail ne "no") {
		push(@emaillist, $sendto);
	}
}
open (EMAIL, ">$NonCGIPath/emaillisttemp.cgi"); 
foreach $dos(@emaillist) {
chomp($dos);
print EMAIL "$dos\n";
}
close(EMAIL);
chmod(0666, "$NonCGIPath/emaillisttemp.cgi");

}  else {

#open exiting email log file
$EmailNumber = $in{'EmailNumber'};

open (EMAILLOG, "$NonCGIPath/emaillog/$EmailNumber.cgi"); 
@thisemail = <EMAILLOG>;
close (EMAILLOG);

$subject = $thisemail[0];
chomp($subject);
$message = $thisemail[1];
chomp($message);
	$message =~ s/<BR>/\n/ig;
	$message =~ s/<P>/\n\r\n/ig;
	$message =~ s/<.+?>//g;
}

#get registered users
open (GETEMAIL, "$NonCGIPath/emaillisttemp.cgi"); 
@themembers = <GETEMAIL>;
close(GETEMAIL);

$TotalMembers = @themembers;
$TotalMembers--; #adjust for array context

#limit processing to 70 emails at a time
$Start = $in{'start'} + 0;
$End = $Start + 70;

if ($TotalMembers <= $End) {
	$End = $TotalMembers;
	$EndLoop = "true";
}  else {
	$StartHere = $End + 1;
}

$StartDisplay = $Start +1;
$EndDisplay = $End +1;

	@thesemembers = @themembers[$Start... $End];
	$EmailLine = "";
foreach $sendto(@thesemembers) {
	chomp($sendto);
	if ($sendto =~ /\S+\@\S+\.\S+/) {

if ($SMTPEmail eq "On") {
&SendEmail;
}  else {
&send_mail("$BBEmail", "$sendto", "$subject", "$message");
}
	$EmailLine .= "$sendto<BR>";
	}

}

if ($EndLoop eq "true") {
$FinishWording = "Die eMail wurde an alle verf&uuml;gbaren Benutzer versandt.";
&FinishMail;
unlink "$NonCGIPath/emaillisttemp.cgi";
}  else {
&ContinueMail;
}

}  else {
&StandardHTMLCP("Sie haben die eMail-Funktion in Ihrer System-Administration deaktiviert.  Sie k&ouml;nnen die Funktion erst nutzen, wenn Sie diese Funktion aktivieren.");
exit;
} #id use email is not on
 } #End Mail USers sr

sub ContinueMail {
print<<TheMail;
<HTML><HEAD>
<meta http-equiv="Refresh" content="2; URL=$CGIURL/ubbmail.cgi?action=mailusers&start=$StartHere&UserName=$UserNameCoded&Password=$PasswordCoded&EmailNumber=$EmailNumber">
</head>
<BODY bgcolor=#FFFFFF>
<center>
<FONT FACE="Verdana, Arial" SIZE="2"><B>
<FONT FACE="Courier New" SIZE="5" COLOR="Maroon"><B>System arbeitet .... bitte warten!</B></FONT>
<P>
Alle Benutzer, welchen den Empfang einer eMail gestatten, erhalten jetzt Ihre eMail.
<P>
Bis jetzt bearbeitete Mitglieder: <FONT FACE="Verdana" SIZE="3" COLOR="Navy">$StartDisplay</font> bis <FONT FACE="Verdana" SIZE="3" COLOR="Navy">$EndDisplay</font>...
<P></center>
Hier die Liste der eMail-Adressen:
<P>
$EmailLine
</FONT>
</BODY>
</HTML>
TheMail

exit;
}

sub FinishMail {
print<<TheMail;
<HTML><HEAD>
</head>
<BODY bgcolor=#FFFFFF>
<center>
<FONT FACE="Verdana, Arial" SIZE="2"><B>
<FONT FACE="Courier New" SIZE="5" COLOR="Maroon"><B>Funktion abgeschlossen!</B></FONT>
<P>
<FONT SIZE="1" FACE="Verdana, Arial"><A HREF="$CGIURL/cpanel.cgi?action=digest">Abo-Center</A> | <A HREF="$CGIURL/cpanel.cgi?action=mail">eMail an alle Benutzer</a> </FONT>
<BR>
$FinishWording
<P></center>
Hier die Liste der eMail-Adressen:
<P>
$EmailLine

</FONT>
</BODY>
</HTML>
TheMail
exit;
}

sub CreateList {
$NameFound = "no";
$ProfileNumber = &GetUserNumber($in{'UserName'});
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

if ($NameFound eq "yes") {
	@theprofile = &OpenProfile("$ProfileNumber.cgi");
			
	if ($Password eq "$theprofile[1]") {
	$Permission = "$theprofile[4]";
	&CheckPermissions;
	  if ($AdminPermission ne "true") {
	    &StandardHTMLCP("Diese Funktion ist ausschlie&szlig;lich Administratoren vorbehalten.");
exit;
	}
	} else {
	&StandardHTMLCP("Das eingebene Kennwort ist nicht korrekt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es noch einmal!");
exit;
	}
		
}  else {
&StandardHTMLCP("Der von Ihnen angegebene Benutzername existiert nicht in unserem System - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es noch einmal!");
exit;
}  ##END IF/ELSE NAME CHECK BLOCK
&GetEmails;

foreach $thisline(@EmailList) {
chomp($thisline);
	($sendto, $profnum) = split(/\?\?/, $thisline);
	@profilestats = &OpenProfile("$profnum.cgi");
	$AllowMassMail = $profilestats[14];
	chomp($AllowMassMail);
	
	if ($AllowMassMail ne "no") {
		push(@emaillist, $sendto);
	}
}

if ($in{'delimit'} eq "comma") {
	$sep = ",";
}  else {
	$sep = "\n";
}

open(LIST, ">$NonCGIPath/emaillist.cgi");
foreach $uno(@emaillist) {
chomp($uno);
print LIST ("$uno" . "$sep");
}
close(LIST);

print<<Confirm;
<HTML><HEAD>
</head>
<BODY bgcolor=#FFFFFF>
<FONT FACE="Verdana, Arial" SIZE="2">
<FONT FACE="Courier New" SIZE="5" COLOR="Maroon"><B>eMail-Liste fertig!</B></FONT>
<blockquote>
Es wurde eine Liste der eMail-Adressen aller registrierten Benutzer erstellt. Die Liste ist als Datei mit dem Namen emaillist.cgi in Ihrem NonCGI-Verzeichnis Ihres UBB gespeichert worden.
<P>
<CENTER><B>Pfad: $NonCGIPath/emaillist.cgi</B></CENTER>
<P>
Sie k&ouml;nnen diese Liste jetzt direkt per Download via FTP auf Ihren PC &uuml;bertragen!
<P>
HINWEIS: Benutzer, welche in ihrem Profil die Annahme von eMails durch Moderatoren oder Administratoren deaktiviert haben, erscheinen nicht in dieser Liste.
</blockquote>

</FONT>
</BODY>
</HTML>
Confirm
}  #end Create List sr

sub DigestStart {

if ( ($in{'UserName'} eq "") || ($in{'Password'} eq "") || ($in{'DigestOption'} eq "") ) {
 &StandardHTMLCP("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}  

&VerifyAdminMod($UserName, $Password);

if ($Proceed ne "true") {
	exit;
}

#continue if get this far...
if ($in{'DigestOption'} eq "1") {
	&CreateNewDigest($Status);
}
elsif ($in{'DigestOption'} eq "2") {
	&DeleteDigest($Status);
}
elsif ($in{'DigestOption'} eq "3") {
	&AddDelSubscriber($Status);
} else {
	&SendDigest($Status);
}
}  #end DigestStart sr

sub CreateNewDigest {
$UserStatus = shift;

$PageTitle = "Neues Abo erstellen";
&DigestTopHTML;

print<<MIDDLE;
Ein Abo ist eine Zusammenstellung von Beitr&auml;gen aus einem bestimmten Forum. Ein Abo mu&szlig; zuerst erstellt werden, bevor Sie Nutzer daf&uuml;r anmelden k&ouml;nnen oder ein Abo an die Nutzer senden k&ouml;nnen. 
<P>
Sobald Sie ein Abo f&uuml;r eines Ihrer Foren erstellt haben, erscheint automatisch der Link "Forum abbonieren" in Ihrem UBB, mit dem sich die Nutzer des UBB f&uuml;r das Abo eintragen k&ouml;nnen. <B>Es k&ouml;nnen sich nur registrierte Nutzer f&uuml;r ein Abo eintragen.</B>  Wir empfehlen, das Sie diese Funktion nicht zu stark nutzen. Nutzer warten bis sie das e-Mail Abo erhalten haben und kommen erst dann auf Ihre Homepage zur&uuml;ck. 
<P>
Sobald Sie ein Abo erstellt haben, k&ouml;nnen Sie die Option "Abo senden" im <A HREF="$CGIURL/cpanel.cgi?action=digest">Abo - Center</A> verwenden, um ein eMail mit dem Abo an alle eingeschriebenen Nutzer zu senden. 
<P>
<FORM ACTION="$CGIURL/ubbmail.cgi" METHOD="POST" NAME="THEFORM">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="adddigest">
<table border=0 width=100%>
<TR bgcolor="#B0BB9D">
<TD colspan=2 align=center>
<FONT SIZE="2" FACE="Verdana, Arial">Neues Abo erstellen:</FONT>
</td></tr>
<TR bgcolor="#C7C6BA">
<TD>
<FONT SIZE="2" FACE="Verdana, Arial">F&uuml;r welches Forum soll ein Abo erstellt werden?</FONT><BR><FONT SIZE="1" FACE="Verdana, Arial">Die angezeigten Foren sind nur die Foren, f&uuml;r die noch kein Abo erstellt wurde bzw. jene Foren, f&uuml;r die Sie eine Berechtigung haben ein Abo zu erstellen.</font>
</td><td valign=top><SELECT NAME="ForumChoice">
MIDDLE

&GetForums;

print<<BOTTOM;
</SELECT></td>
</tr>
</table>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">Hinweis: Sind Sie ein Moderator, dann k&ouml;nnen Sie ausschlie&szlig;lich Abos f&uuml;r das Forum erstellen, welches Sie moderieren. Administratoren k&ouml;nnen Abo's f&uuml;r alle Foren erstellen. Sie k&ouml;nnen kein Abo f&uuml;r ein privates Forum erstellen.</FONT>
<HR>
<CENTER><FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Identifizieren Sie sich:</font>
<p>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
Benutzername: <INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;&nbsp;&nbsp; Kennwort: <INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13></FONT></B>
<P>
<CENTER><INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Neues Abo erstellen"></CENTER>
<P><BR>
</form>
</body></html>
BOTTOM
} #end CreateNewDigest

sub DigestTopHTML {
print<<HEADER;
<HTML>
<HEAD>
	<TITLE>$BBName</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
var testUserNameCP = getCookie("UserNameCP");
var CookieUNCP = escape("$UserName");
var CookiePWCP = escape("$Password");

	if ((testUserNameCP == null) && (CookieUNCP != "")){
	  	document.cookie = "UserNameCP=" + CookieUNCP + ";";
		document.cookie = "PasswordCP=" + CookiePWCP + ";";
	} 

function SetCursor() {
if (testUserNameCP != null) {  
	document.forms[0].UserName.value = getCookie("UserNameCP");
document.forms[0].Password.value = getCookie("PasswordCP");
	}  
}

function Check(form)  {
if ((form.Password.value == "") || (form.UserName.value == ""))  {
	alert ("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	return false
	}  else  {
	return true
	}
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length; 
            return unescape(dc.substring(begin, end));  }
}
return null;
}
// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</HEAD>
<BODY bgcolor="#FFFFFF" link="#000080" vlink="#808000" onLoad="SetCursor()">
<BR>
<center>
<FONT SIZE="5" FACE="Courier New"><B>$PageTitle</B></FONT>
</center>
<FONT SIZE="2" FACE="Verdana, Arial">
<p>
HEADER

}  #end DigestTopHTML

sub AddDelSubscriber {
$UserStatus = shift;

$PageTitle = "Abonnenten hinzuf&uuml;gen oder l&ouml;schen";
&DigestTopHTML;

print<<UPMIDDLE;
Benutzer k&ouml;nnen sich f&uuml;r Abos in Ihrem <A HREF="$CGIURL/ubbmail.cgi?action=subscribe">Abo-Center</A> selbst ein- und austragen.  Als Administrator oder Moderator k&ouml;nnen Sie hier ebenfalls Abonnenten ein- oder austragen. Beachten Sie, da&szlig; alle Abonnenten registrierte Benutzer sein m&uuml;ssen. Ihre Angaben werden nicht verifiziert.
<P>
<FORM ACTION="$CGIURL/ubbmail.cgi" METHOD="POST" NAME="THEFORM">

<INPUT TYPE="HIDDEN" NAME="action" VALUE="subscriberedit">
Abonnenten hinzuf&uuml;gen oder l&ouml;schen von folgendem Abo: 
<SELECT NAME="ForumChoice">
<OPTION VALUE="" SELECTED>Bitte ausw&auml;hlen!
UPMIDDLE

&GetForums2;

print<<BOTTOM;
</select>
<P>
<table border=0 width=100%>
<TR bgcolor="#B0BB9D">
<TD align=center>
<FONT SIZE="2" FACE="Verdana, Arial">Abonnenten hinzuf&uuml;gen:</FONT>
</td>
<TD align=center>
<FONT SIZE="2" FACE="Verdana, Arial">Abonnenten entfernen:</FONT>
</td>
</tr>
<TR bgcolor="#C7C6BA">
<TD>
<FONT SIZE="1" FACE="Verdana, Arial">Bitte geben Sie hier die eMail-Adresse(n) ein, die Sie diesem Abo hinzuf&uuml;gen m&ouml;chten. Mehrere Adressen geben Sie bitte jeweils mit einem Leerschritt ein (wie z.B. ted\@test.com bob\@youremail.com).</font><BR>
<TEXTAREA NAME="AddEmail" ROWS=4 COLS=20>
</TEXTAREA>
</td>
<TD>
<FONT SIZE="1" FACE="Verdana, Arial">Bitte geben Sie hier die eMail-Adresse(n) ein, die Sie von diesem Abo entfernen m&ouml;chten. Mehrere Adressen geben Sie bitte jeweils mit einem Leerschritt ein (wie z.B. ted\@test.com bob\@youremail.com).</font><BR>
<TEXTAREA NAME="DeleteEmail" ROWS=4 COLS=20>
</TEXTAREA>
</td>
</tr>
</table>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">HINWEIS: Moderatoren k&ouml;nnen nur Abos aus dem moderierten Forum verwalten. Abos f&uuml;r private Foren sind nicht m&ouml;glich.</FONT>
<HR>
<CENTER><FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Identifizieren Sie sich:</font>
<p>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
Benutzername: <INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;&nbsp;&nbsp; Kennwort: <INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13></FONT></B>
<P>
<CENTER><INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="&Auml;nderungen speichern!"></CENTER>
<P><BR>
</form>
</body></html>
BOTTOM
} #end AddDelSubscriber

sub DigestTopHTMLnj {
print<<HEADER;
<HTML>
<HEAD>
	<TITLE>$BBName</TITLE>
</HEAD>
<BODY bgcolor="#FFFFFF" link="#000080" vlink="#808000">
<BR>
<center>
<FONT SIZE="5" FACE="Courier New"><B>$PageTitle</B></FONT>
</center>
<FONT SIZE="2" FACE="Verdana, Arial">
<p>
HEADER

}  #end DigestTopHTMLnj

sub GetForums {
@forumlist = &OpenForumsFile;
@digestsummary = &GetDigestSummary;
@semifinal = @blank;
@final = @blank;

foreach $uno(@forumlist) {
chomp($uno);
@thisforum = split(/\|/, $uno);
if (($thisforum[3] eq "On") && ($thisforum[6] ne "private")) {
if ($UserStatus eq "Administrator") {
$goodline = "$thisforum[8]|$thisforum[1]";
push(@semifinal, $goodline);
} else {
$Moderator = ("Forum" . "$thisforum[8]" . "Moderator");
$Moderator = $$Moderator;
@mods = split(/\|\|\^\|\|/, $Moderator);

$ModMatch = "";
foreach $unomod(@mods) {
if ($unomod eq "$UserName") {
	$ModMatch = "true";
}
}
	if ($ModMatch eq "true") {
		$goodline = "$thisforum[8]|$thisforum[1]";
		push(@semifinal, $goodline);
	}
}
}
}

#now compare list of eligible forums with list of existing digests

foreach $one(@semifinal) {
chomp($one);

if (@digestsummary) {
	($thisnumber, $junk) = split(/\|/, $one);
	$DeleteIt = "";
	foreach $check(@digestsummary) {
		@checkdigest = split(/\|/, $check);
		if ($checkdigest[0] eq "$thisnumber") {
			$DeleteIt = "true";
		}
	}
	if ($DeleteIt ne "true") {
		push(@final, $one);
	}
}  else {
push(@final, $one);
}
}

if ($final[0] eq "") {
	print qq(<OPTION value="">Es konnten aufgrund unvollst&auml;ndiger Angaben keine Foren addiert werden.);
	
}  else {
foreach $thou(@final) {
chomp($thou);
($thenum, $thename) = split(/\|/, $thou);
print qq(<OPTION value="$thenum">$thename);
}
}
}  #end GetForums


sub GetForums2 {
@digestsummary = &GetDigestSummary;
@final = @blank;

foreach $uno(@digestsummary) {
chomp($uno);
@thisdigest = split(/\|/, $uno);
if ($UserStatus eq "Administrator") {
push(@final, $thisdigest[0]);
} else {
$Moderator = ("Forum" . "$thisdigest[1]" . "Moderator");
$Moderator = $$Moderator;
@mods = split(/\|\|\^\|\|/, $Moderator);

$ModMatch = "";
foreach $unomod(@mods) {
if ($unomod eq "$UserName") {
	$ModMatch = "true";
}
}
	if ($ModMatch eq "true") {
		push(@final, $thisdigest[0]);
	}
}
}

if ($final[0] eq "") {
	print qq(<OPTION value="">Keine geeigneten Foren vorhanden);
	
}  else {
foreach $thou(@final) {
chomp($thou);
@thisfor = &GetForumRecord($thou);
my $ForumName = $thisfor[1];
print qq(<OPTION value="$thou">$ForumName);
}
}
}  #end GetForums2

sub Subscribe {
$PageTitle = "$BBName<BR>Abo - Center";
&DigestTopHTML2;

print<<MIDDLE;
<FONT SIZE="1" FACE="$FontFace"><A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">zur&uuml;ck zu den Foren</A></FONT>
<blockquote>
Ausschlie&szlig;lich registrierte Nutzer k&ouml;nnen Sie f&uuml;r ein Abo anmelden. Wenn Sie sich f&uuml;r ein Abo anmelden, erhalten Sie periodisch e-Mails mit Beitr&auml;gen eines Zeitraums von einem bestimmten Forum. Um sich f&uuml;r ein Abo anzumelden oder abzumelden, m&uuml;ssen Sie Ihren Benutzernamen und Ihr Passwort angeben. Abo's sind nicht f&uuml;r alle Foren verf&uuml;gbar. Das Anmelden ist kostenfrei.
<P>
Aus vertraulichen Gr&uuml;nden sehen Sie nicht, welche Abo's Sie bereits abonniert haben. Wollen Sie eine &Uuml;bersicht per e-Mail erhalten, f&uuml;r welche Abo's Sie bereits angemeldet sind, klicken Sie bitte <A HREF="$CGIURL/ubbmail.cgi?action=subscribelistintro">hier</A>.
<P>
Wir haben eine Liste der verf&uuml;gbaren Abo's erstellt. Wollen Sie sich f&uuml;r ein Abo anmelden, w&auml;hlen Sie den <b>Anmelden</b> neben dem Abo. Wollen Sie sich abmelden, w&auml;hlen Sie <b>Abmelden</b> neben dem entsprechenden Abo. 
<P>
<FORM ACTION="$CGIURL/ubbmail.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="subscribesubmit">
<center>

<TABLE border=0 width=90%>
<TR $TableColorStrip>
<TD>
<FONT SIZE="$TextSize" Color="$TableStripTextColor" FACE="$FontFace">Forum - Abo</FONT>
</td>
<TD>
<FONT SIZE="$TextSize" Color="$TableStripTextColor" FACE="$FontFace">Auswahl</FONT>
</td>
</tr>
MIDDLE

@digsum = &GetDigestSummary;  

foreach $uno(@digsum) {
if ($Alternate eq "$AltColumnColor1") {
	$Alternate = "$AltColumnColor2";
}  else {
	$Alternate = "$AltColumnColor1";
}

@thisdig = split(/\|/, $uno);
@thisfor = &GetForumRecord($thisdig[0]);
my $ForumName = $thisfor[1];
print<<THIS;
<TR $Alternate><TD>
<FONT SIZE="$TextSize" FACE="$FontFace">$ForumName</FONT>
</td>
<TD>
<FONT SIZE="$TextSize" FACE="$FontFace">
<INPUT TYPE="RADIO" NAME="Subscribe$thisdig[0]" VALUE="yes"> Anmelden<BR>
<INPUT TYPE="RADIO" NAME="Subscribe$thisdig[0]" VALUE="null" CHECKED> Abmelden

</FONT>
</td>
</tr>
THIS
}

print<<BOTTOM;
</table>
<TABLE BORDER=0>
<TR>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">Ihr Benutzername:</FONT></td><TD><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=40></td></tr>
<TR>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">Ihr Kennwort:</FONT></td><TD><INPUT TYPE="PASSWORD" NAME="Password" SIZE=20 MAXLENGTH=40></td></tr>
</table></center>
</blockquote>
<CENTER><INPUT TYPE="SUBMIT" NAME="submit" VALUE="Identifikation senden"></CENTER>

</FORM>
<center>
$Footer
</center>
</font>
</body></html>
BOTTOM

}  # end subscribe

sub DigestTopHTML2 {
print<<HEADER;
<HTML>
<HEAD>
	<TITLE>$BBName - Abo - Center</TITLE>
$HeaderInsert
</HEAD>
 <BODY $BGColor $PageBackground  text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT SIZE="2" FACE="$FontFace" COLOR="$TextColor">
$Header
</font>
<BR>
<center>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>$PageTitle</B></FONT>
</center>
<FONT SIZE="$TextSize" FACE="$FontFace">
<p>
HEADER
}  #end DigestTopHTML2

sub AddDigest {
#verify id

if ( ($in{'UserName'} eq "") || ($in{'Password'} eq "") || ($in{'ForumChoice'} eq "") ) {
 &StandardHTMLCP("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}  

#verify Admin/Moderator
$NameFound = "no";
$ProfileNumber = &GetUserNumber($UserName);
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

if ($NameFound eq "yes") {
	@theprofile = &OpenProfile("$ProfileNumber.cgi");
			
	if ($Password eq "$theprofile[1]") {
		$Status = "$theprofile[8]";
   if ($Status !~ /[Administrator|Moderator]/i)  {
	    &StandardHTMLCP("Diese Funktion ist ausschlie&szlig;lich f&uuml;r Moderatoren oder Administratoren bestimmt.");
exit;
	   }
	} else {
	&StandardHTMLCP("Das eingegebene Kennwort ist nicht korrekt - versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
	}
		
}  else {
&StandardHTMLCP("Der von Ihnen angegebene Benutzername existiert nicht in unserem System, versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
}  ##END IF/ELSE NAME CHECK BLOCK

@thisforum = &GetForumRecord($in{'ForumChoice'});
$ForumName = $thisforum[1];

unless (-e "$NonCGIPath/digests/digestsummary.cgi") {
mkdir ("$NonCGIPath/digests", 0777);
chmod(0770, "$NonCGIPath/digests");
}

#add new digest to database
open(ADD, ">>$NonCGIPath/digests/digestsummary.cgi");
print ADD "$in{'ForumChoice'}||\n";
close(ADD);

chmod (0777, "$NonCGIPath/digests/digestsummary.cgi");

$PageTitle = "Neues Abo erstellt!";
&DigestTopHTMLnj;

print<<THIS;
Vielen Dank!  Folgendes Abo wurde erstellt:
<P>
$ForumName
<P>
Dieses Abo ist jetzt in dem <A HREF="$CGIURL/ubbmail.cgi?action=subscribe">Abo - Center</A> gelistet, wo sich Ihre Benutzer jetzt eintragen k&ouml;nnen.
<P>
<A HREF="$CGIURL/cpanel.cgi?action=digest">Zur&uuml;ck zum Abo-Center ...</A>
</font>
</body></html>
THIS

}  #end AddDigest

sub DeleteTheDigest {
#verify id

if ( ($in{'UserName'} eq "") || ($in{'Password'} eq "") || ($in{'ForumChoice'} eq "") ) {
 &StandardHTMLCP("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}  

#verify Admin/Moderator
$NameFound = "no";
$ProfileNumber = &GetUserNumber($UserName);
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

if ($NameFound eq "yes") {
	@theprofile = &OpenProfile("$ProfileNumber.cgi");
			
	if ($Password eq "$theprofile[1]") {
		$Status = "$theprofile[8]";
   if ($Status !~ /[Administrator|Moderator]/i)  {
	    &StandardHTMLCP("Diese Funktion ist ausschlie&szlig;lich f&uuml;r Moderatoren oder Administratoren bestimmt.");
exit;
	   }
	} else {
	&StandardHTMLCP("Das eingegebene Kennwort ist nicht korrekt - versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
	}
		
}  else {
&StandardHTMLCP("Der von Ihnen angegebene Benutzername existiert nicht in unserem System, versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
}  ##END IF/ELSE NAME CHECK BLOCK

open(DIGESTS, "$NonCGIPath/digests/digestsummary.cgi");
@currentdigests = <DIGESTS>;
close(DIGESTS);
@revisedlist = @blank;

foreach $uno(@currentdigests) {
chomp($uno);
@thisone = split(/\|/, $uno);
unless ($thisone[0] eq "$in{'ForumChoice'}") {
	push (@revisedlist, $uno);
}  
}

#add new digest to database
&Lock("lock.file");
open(ADD, ">$NonCGIPath/digests/digestsummary.cgi");
foreach $digline(@revisedlist) {
	chomp($digline);
	print ADD "$digline\n";
}
close(ADD);
&Unlock("lock.file");

chmod (0777, "$NonCGIPath/digests/digestsummary.cgi");
#delete email list associated with this digest
unlink "$NonCGIPath/digests/emaillist$in{'ForumChoice'}.cgi";

$PageTitle = "Abo gel&ouml;scht";
&DigestTopHTMLnj;

print<<THIS;
Vielen Dank!  Das von Ihnen gew&auml;hlte Abo wurde gel&ouml;scht.
<P>
<A HREF="$CGIURL/cpanel.cgi?action=digest">Zur&uuml;ck zum Abo-Center ...</A>
</font>
</body></html>
THIS
}  #end DeleteDigest

sub SubscribeSubmit {
#check registration
if (($in{'UserName'} eq "") || ($in{'Password'} eq "")) {
&StandardHTML("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
} 

$NameFound = "no";

$ProfileNumber = &GetUserNumber($UserName);
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

if ($NameFound eq "yes") {
#Check Password Now	
	@thisprofile = &OpenProfile("$ProfileNumber.cgi");
         if ($in{'Password'} eq "$thisprofile[1]") {
		    $Email = $thisprofile[2];
            $Proceed = "true";
         }
    } ## END IF MEMBER = Username.cgi condition

if ($NameFound ne "yes") {
   &StandardHTML("Der von Ihnen angegebene Benutzername existiert nicht in unserem System, versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
}
if (($NameFound eq "yes") && ($Proceed ne "true")) {
   	&StandardHTML("Das eingegebene Kennwort ist nicht korrekt - versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
}

if ($Email !~ /\S+\@\S+\.\S+/) {
	&StandardHTML("Das System kann Sie aufgrund falschen Formats der von Ihnen in der Registration angegebenen eMail-Adresse keinem Abo hinzuf&uuml;gen.  Beachten Sie, da&szlig; Leerschritte in Ihrer eMail-Adresse nicht gestattet sind.  Pr&uuml;fen Sie Ihr Profil und &auml;ndern Sie es entsprechend.");
exit;
}
$YourEmail = lc($Email);
@digsum = &GetDigestSummary;

foreach $one(@in) {
	($Name, $Value) = split ("=", $one);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	if ($Name =~ /Subscribe/) {
		if ($Value eq "yes") {
			push(@addlist, $Name);
		}
	}
}

foreach $uno(@digsum) {
$Dupe = "";
@revised = @blank;

@thisdigest = split(/\|/, $uno);

#check to see if they are subscribing or unsubscribing from this forum
$Add = "";
CHECKADD: foreach $checkadd(@addlist) {
	if ($checkadd eq "Subscribe$thisdigest[0]") {
		$Add = "true";
		last CHECKADD;
	}
}

open (DIGLIST, "$NonCGIPath/digests/emaillist$thisdigest[0].cgi");
@theseemail = <DIGLIST>;
close(DIGLIST);

if ($Add eq "true") {

CHECKER: foreach $check(@theseemail) {
chomp($check);
if ($check eq "$YourEmail") {
	$Dupe = "true";
	last CHECKER;
}
}

if ($Dupe ne "true") {
&Lock("lock.file");
open(EMAILS, ">>$NonCGIPath/digests/emaillist$thisdigest[0].cgi");
print EMAILS "$YourEmail\n";
close(EMAILS);
&Unlock("lock.file");
chmod(0777, "$NonCGIPath/digests/emaillist$thisdigest[0].cgi");
}

}  else {

@revised = @blank;
#else remove
foreach $check(@theseemail) {
chomp($check);
if ($check ne "$YourEmail") {
	push(@revised, $check);
}
}

&Lock("lock.file");
open(EMAILS, ">$NonCGIPath/digests/emaillist$thisdigest[0].cgi");
foreach $checked(@revised) {
chomp($checked);
print EMAILS "$checked\n";
}
close(EMAILS);
&Unlock("lock.file");
chmod (0777, "$NonCGIPath/digests/emaillist$thisdigest[0].cgi");
}
}
$PageTitle = "Abos aktualisiert";
&DigestTopHTML2;

print<<BOTTOM;
<P>
Vielen Dank.  Ihre Abonnements wurden aktualisiert.
<P>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">Zur&uuml;ck zu den Foren ...</A>
<P>
$Footer
</font>
</body></html>
BOTTOM

}  #end subscribe submit

sub GetDigestSummary {
open (DIG, "$NonCGIPath/digests/digestsummary.cgi");
@thedigsummary = <DIG>;
close(DIG);
return(@thedigsummary);
}

sub DeleteDigest {
$UserStatus = shift;

$PageTitle = "Abo l&ouml;schen";
&DigestTopHTML;

print<<MIDDLE;
Sie wollen ein Abo l&ouml;schen, welches Sie zuvor erstellt haben.  Das L&ouml;schen eine Abo's wirkt sich nicht auf die Foren-Beitr&auml;ge aus.  Es entfernt das Abo aus Ihrer Abo-Liste in der sich die Nutzer f&uuml;r diese Abo anmelden bzw. abmelden k&ouml;nnen.
<P>
<FORM ACTION="$CGIURL/ubbmail.cgi" METHOD="POST" NAME="THEFORM">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="deletedigest">
<table border=0 width=100%>
<TR bgcolor="#B0BB9D">
<TD colspan=2 align=center>
<FONT SIZE="2" FACE="Verdana, Arial">Abo l&ouml;schen:</FONT>
</td></tr>
<TR bgcolor="#C7C6BA">
<TD>
<FONT SIZE="2" FACE="Verdana, Arial">Welches Abo l&ouml;schen?</FONT><BR><FONT SIZE="1" FACE="Verdana, Arial">Die Foren-Liste zeigt alle Foren f&uuml;r die ein Abo existiert und f&uuml;r welches Sie die Berechtigung haben.</font>
</td><td valign=top><SELECT NAME="ForumChoice">
MIDDLE

&GetForums2;

print<<BOTTOM;
</SELECT></td>
</tr>
</table>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000"><b>Hinweis:</b> Sind Sie ein Moderator, dann k&ouml;nnen Sie nur Abo's f&uuml;r das Forum l&ouml;schen, welches Sie moderieren.  Administratoren k&ouml;nnen alle Abo's l&ouml;schen.  Sie k&ouml;nnen kein Abo f&uuml;r ein privates Forum erstellen.</FONT>
<HR>
<CENTER><FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Identifizieren Sie sich:</font>
<p>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
Benutzername: <INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;&nbsp;&nbsp; Kennwort: <INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13></FONT></B>
<P>
<CENTER><INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="&Auml;nderungen speichern"></CENTER>
<P><BR>
</form>
</body></html>
BOTTOM
}


sub SubscriberEdit {
#verify id

if ( ($in{'UserName'} eq "") || ($in{'Password'} eq "") || ($in{'ForumChoice'} eq "") ) {
 &StandardHTML("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}  

#verify Admin/Moderator
$NameFound = "no";
$ProfileNumber = &GetUserNumber($UserName);
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

if ($NameFound eq "yes") {
	@theprofile = &OpenProfile("$ProfileNumber.cgi");
			
	if ($Password eq "$theprofile[1]") {
		$Status = "$theprofile[8]";
   if ($Status !~ /[Administrator|Moderator]/i)  {
	    &StandardHTMLCP("Diese Funktion ist ausschlie&szlig;lich f&uuml;r Moderatoren oder Administratoren bestimmt.");
exit;
	   }
	} else {
	&StandardHTMLCP("Das eingegebene Kennwort ist nicht korrekt - versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
	}
		
}  else {
&StandardHTMLCP("Der von Ihnen angegebene Benutzername existiert nicht in unserem System, versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
}  ##END IF/ELSE NAME CHECK BLOCK

@thisforum = &GetForumRecord($in{'ForumChoice'});
$ForumName = $thisforum[1];

unless (-e "$NonCGIPath/digests/digestsummary.cgi") {
mkdir ("$NonCGIPath/digests", 0777);
chmod(0777, "$NonCGIPath/digests");
}

#open email list for this digest
open(EMAILLIST, "$NonCGIPath/digests/emaillist$in{'ForumChoice'}.cgi");
@thislist = <EMAILLIST>;
close(EMAILLIST);
$AddEmail = &decodeURL($in{'AddEmail'});
$DelEmail = &decodeURL($in{'DeleteEmail'});
	$AddEmail = &ConvertSpaces($AddEmail);
	$DelEmail = &ConvertSpaces($DelEmail);

@addfinal = @blank;
@delfinal = @blank;
$InvalidList = "";
$DupeList = "";
$AddList = "";
$DeleteList = "";
@revisedlist = @blank;

@addarray = split(/\s{1,}/, $AddEmail);
@delarray = split(/\s{1,}/, $DelEmail);

if ($addarray[0] ne "") {

	foreach $one(@addarray) {
		chomp(@one);
		$thisone = lc($one);
		$Invalid = "";
		$Dupe = "";
		#make sure it is a valid email-
		if ($thisone !~ /\S+\@\S+\.\S+/) {
			$InvalidList .= "$thisone<BR>";
			$Invalid = "true";
		}  else {
			CHECKER: foreach $check(@thislist) {
				chomp($check);
				if ($thisone eq "$check") {
					$DupeList .= "$thisone<BR>";
					$Dupe = "true";
					last CHECKER;
				}
			}
		
		}
		if (($Dupe ne "true") && ($Invalid ne "true")) {
			$AddList .= "$thisone<BR>";
			push(@thislist, $thisone);
		}
	}

} #end if add array exists

if ($delarray[0] ne "") {

	foreach $check(@thislist) {
	$Delete = "";
		chomp($check);
		CHECKER: foreach $delone(@delarray) {
		chomp(@delone);
		$thisdel = lc($delone);
			if ($thisdel eq "$check") {
				$DeleteList .= "$thisdel<BR>";
				$Delete = "true";
				last CHECKER;
			}
		}
		if ($Delete ne "true") {
			push(@revisedlist, $check);
		}
		
	}
		
} #end if del array exists

if ($DeleteList ne "") {
	@thislist = @revisedlist;
}

open(ADJ, ">$NonCGIPath/digests/emaillist$in{'ForumChoice'}.cgi");
foreach $good(@thislist) {
chomp($good);
print ADJ "$good\n";
}
close(ADJ);
chmod (0777, "$NonCGIPath/digests/emaillist$in{'ForumChoice'}.cgi");

$PageTitle = "Subscribers Updated for $ForumName Digest";
&DigestTopHTMLnj;

if ($AddList ne "") {
	$AddListWording = "<B>Abonennten hinzugef&uuml;gt:</B><P>$AddList<P>";
}
if ($DeleteList ne "") {
	$DeleteListWording = "<B>Abonnenten gel&ouml;scht:</B><P>$DeleteList<P>";
}
if ($InvalidList ne "") {
	$InvalidListWording = "<B>Die folgenden Adressen wurden in einem ung&uuml;ltigem Format angegeben und konnten dadurch nicht hinzugef&uuml;gt oder gel&ouml;scht werden:</B><P>$InvalidList<P>";
}
if ($DupeList ne "") {
	$DupeListWording = "<B>Die folgenden Adressen waren bereits f&uuml;r dieses Abo registriert und wurden dadurch nicht erneut hinzugef&uuml;gt:</B><P>$DupeList<P>";
}
print<<THIS;
Danke!  Folgende &Auml;nderungen der Benutzerliste f&uuml;r das Abo des Forums $ForumName wurde durchgef&uuml;hrt:
<P>
$AddListWording $DeleteListWording $InvalidListWording
$DupeListWording
<HR>
<A HREF="$CGIURL/cpanel.cgi?action=digest">Zur&uuml;ck zum Abo - Center ...</A>
</font>
</body></html>
THIS

}  #end SubscriberEdit

sub ConvertSpaces {
$Converter = shift;
$Converter =~ s/\n\r\n/ /g;
$Converter =~ s/\n/ /g;
$Converter =~ s/\r/ /g;
return($Converter);
}

sub SendDigest {
$UserStatus = shift;

$PageTitle = "Versenden eines Abos";
&DigestTopHTML;

print<<MIDDLE;
Sie k&ouml;nnen ein Abo an alle angemeldeten Nutzer senden, wenn Sie dieses Formular ausgef&uuml;llt haben.  Klicken Sie auf SENDEN um die Funktion zu starten. Klicken Sie erst auf SENDEN, wenn Sie sicher sind, da&szlig; alle Informationen korrekt sind.
<P>
<FORM ACTION="$CGIURL/ubbmail.cgi" METHOD="POST" NAME="THEFORM">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="sendthedigest">
<table border=0 width=100%>
<TR bgcolor="#B0BB9D">
<TD valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">Abo ausw&auml;hlen:</FONT>
</td>
<td valign=top><SELECT NAME="ForumChoice">
MIDDLE

&GetForums2;

print<<BOTTOM;
</SELECT></td>
</tr>
<TR bgcolor="#C7C6BA">
<TD>
<FONT SIZE="2" FACE="Verdana, Arial">Zeitraum:</FONT><BR><FONT SIZE="1" FACE="Verdana, Arial">W&auml;hlen Sie den Zeitraum der Beitr&auml;ge die gesendet werden sollen.  Sie k&ouml;nnen z.B. die Beitr&auml;ge der letzten Woche, der letzten zwei Wochen oder alle Beitr&auml;ge seit dem letzten Versand des Abo's w&auml;hlen (maximal die letzten 31 Tage).</font>
</td>
<TD valign=top>
<SELECT NAME="TimeSpan">
	<OPTION value="last">seit dem letzten Abo (maximal 31 Tage)
	<OPTION value="1">seit gestern
	<OPTION value="7">letzten 7 Tage
	<OPTION value="14">letzten 14 Tage
	<OPTION value="21">letzten 21 Tage
	<OPTION value="31">letzten 31 Tage
</SELECT></td>
</tr>

<TR bgcolor="#B0BB9D">
<TD valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">nur Beitr&auml;ge oder Beitr&auml;ge und Antworten</FONT><BR><FONT SIZE="1" FACE="Verdana, Arial">Sie k&ouml;nnen entweder nur den Beitrag senden (kompl. Original-Beitrag) oder den Beitrag mit allen Antworten.</font>
</td><TD valign=top>
<SELECT NAME="Type">
	<OPTION value="topics">nur Beitr&auml;ge
	<OPTION value="all">Beitr&auml;ge und Antworten
</SELECT></td>
</tr>

<TR bgcolor="#C7C6BA">
<TD valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">Start-Nachricht</FONT><BR><FONT SIZE="1" FACE="Verdana, Arial">Wenn Sie m&ouml;chten, k&ouml;nnen Sie einen einf&uuml;hrenden Text in Ihr Abo einf&uuml;gen.  Benutzen Sie kein HTML in dieser Nachricht.</font>
</td><TD valign=top>
<TEXTAREA NAME="IntroMessage" ROWS=5 COLS=25>
</TEXTAREA>
</td>
</tr>
</table>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000"><b>Hinweis:</b> Sind Sie ein Moderator, dann k&ouml;nnen Sie ein Abo nur f&uuml;r das Forum erstellen, das Sie moderieren.  Administratoren k&ouml;nnen Abo's f&uuml;r alle Foren erstellen.  Sie k&ouml;nnen kein Abo f&uuml;r private Foren erstellen.</FONT>
<HR>
<CENTER><FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Identifizieren Sie sich:</font>
<p>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
Benutzername: <INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;&nbsp;&nbsp; Kennwort: <INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13></FONT></B>
<P>
<CENTER><INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Abo jetzt senden!"></CENTER>
<P><BR>
</form>
</body></html>
BOTTOM
} #end SendDigest


sub SendTheDigest {
#verify id

if ( ($in{'UserName'} eq "") || ($in{'Password'} eq "") || ($in{'ForumChoice'} eq "") ||  ($in{'Type'} eq "") || ($in{'TimeSpan'} eq "")) {
 &StandardHTMLCP("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}  

#verify Admin/Moderator
$NameFound = "no";
$ProfileNumber = &GetUserNumber($UserName);
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

if ($NameFound eq "yes") {
	@theprofile = &OpenProfile("$ProfileNumber.cgi");
			
	if ($Password eq "$theprofile[1]") {
		$Status = "$theprofile[8]";
   if ($Status !~ /[Administrator|Moderator]/i)  {
	    &StandardHTMLCP("Diese Funktion ist ausschlie&szlig;lich f&uuml;r Moderatoren oder Administratoren bestimmt.");
exit;
	   }
	} else {
	&StandardHTMLCP("Das eingegebene Kennwort ist nicht korrekt - versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
	}
		
}  else {
&StandardHTMLCP("Der von Ihnen angegebene Benutzername existiert nicht in unserem System, versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
exit;
}  ##END IF/ELSE NAME CHECK BLOCK

@thisforum = &GetForumRecord($in{'ForumChoice'});
$ForumName = $thisforum[1];
my $DigestNumber = $in{'ForumChoice'};
my $TimeSpan = $in{'TimeSpan'};
$number = $DigestNumber;
$ExactPath = "Forum$number";

#open email list for this digest
open(EMAILLIST, "$NonCGIPath/digests/emaillist$in{'ForumChoice'}.cgi");
	@thislist = <EMAILLIST>;
close(EMAILLIST);
$TotalEmails = @thislist;

#open digest summary
@digestsummary = &GetDigestSummary;
foreach $one(@digestsummary) {
@thisdigest = split(/\|/, $one);
if ($DigestNumber eq "$thisdigest[0]") {
	$LastJDate = $thisdigest[2];
	chomp($LastJDate);
}
}

&GetDateTime;
@months = ("blank" , "Januar", "Februar", "M&auml;rz", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember");
$ThisMonth = $months[$mon];
($TodayJules, $junk) = split(/\./, $LastLoginJulian);
$subject = "$ForumName - Abo: Ausgabe vom $mday $ThisMonth $JSYear";

if ($in{'start'} eq "") {
$Body = "Sie erhalten diese eMail, da Sie sich f&uuml;r dieses Abo angemeldet haben.\n*************\n\r\n";
$ThisBody = $in{'IntroMessage'};
$ThisBody = &decodeURL($ThisBody);
$ThisBody =~ s/<.+?>//g;
$Body .= "$ThisBody\n\r\n";

if ($TimeSpan eq "last") {
$RealSpan = $TodayJules - $LastJDate;
if ($RealSpan >= 31) {
	$TimeSpan = 31;
}  else {
	$TimeSpan = $RealSpan;
}
}

$JulesCutOff = $TodayJules - $TimeSpan;

#open threads file for this forum
open(THREADS, "$ForumsPath/Forum$DigestNumber/forum$DigestNumber.threads");
	@threadsarray = <THREADS>;
close(THREADS);
$TotalTopics = @threadsarray;

#open last number file
open (FORSUMM, "$ForumsPath/Forum$DigestNumber/lastnumber.file");
@foruminfo = <FORSUMM>;
close (FORSUMM);

chomp($foruminfo[1]);
$LastNumberVerify = $foruminfo[1] + 0;

if ($TotalTopics != $LastNumberVerify) {
&SetThreadInfo;
&ForumSummary($number);
} else {
@sortfinalarray = sort(@threadsarray);
@finalarray = reverse(@sortfinalarray);
}
#now we have final array

CHECKEACH: for $eachone(@finalarray) {
	chomp($eachone);
	@threadinfo2 = split(/\|\^\|/, $eachone);
	$PostDateJulian2 = $threadinfo2[0];
	($PostDateJulian, $junk) = split(/\./, $PostDateJulian2);
	
	#do date compare on post julian

	if ($PostDateJulian >= $JulesCutOff) {
	push(@goodarray2, $eachone);
	}  else {
	last CHECKEACH;
	}
}  #foreach eachone

foreach $uno(@goodarray2) {
@thistopic = split(/\|\^\|/, $uno);
my $TopicNumber = $thistopic[1];
my $ThisTopic = $thistopic[2];

		$Body .= "\n******************\nTOPIC: $ThisTopic\n";
		
#open the ubb file

my @threadinformation = &OpenThread("$TopicNumber.cgi");
CYCLE: foreach $line(@threadinformation) {
@thisline = split(/\|\|/, $line);
	if ($thisline[0] eq "Z") {
		$ThisUserName = $thisline[2];
		$theDate = "$thisline[3]";
		$theTime = $thisline[4];
		$Message = $thisline[6];
		$Message = &ConvertMessage($Message);
		$Message =~ s/<.+?>//g;
		$reg = $thisline[8];
		chomp($reg);
		if ($thisline[1] eq "000000") {
			$Body .= "von $ThisUserName am $theDate $theTime\n\r\n";
			$Body .= "$Message\n------------\n";
		}  else {
			if ($in{'Type'} eq "topics") {
				last CYCLE;
			} else {
			$Body .= "ANTWORT von $ThisUserName am $theDate $theTime:\n";
			$Body .= "$Message\n------------\n";
			}
		}
		
}
}		

}

}  else {
$DigestFile = $in{'DigestFile'};
open (TEMP, "$NonCGIPath/digests/$DigestFile");
@BodyArray = <TEMP>;
close(TEMP);

foreach $row(@BodyArray) {
chomp($row);
$Body .= &ConvertMessage($row);
}
} #end if/else start eq 0

#do emails in batches of 50
$TotalArray = $TotalEmails - 1; #adjust for array context
#limit processing to 50 emails at a time
$Start = $in{'start'} + 0;
$End = $Start + 50;

if ($TotalArray <= $End) {
	$End = $TotalArray;
	$EndLoop = "true";
}  else {
	$StartHere = $End + 1;
}

$StartDisplay = $Start +1;
$EndDisplay = $End +1;

	@thislist = @thislist[$Start... $End];
	
if (($in{'start'} eq "") && ($EndLoop ne "true")) {
## store the body in a text file temporarily until all emails are sent
$DigestFile = "temp-$number-$JSYear$mon$mday.cgi";
$ThisBody = &ConvertReturns($Body);
open (TEMP, ">$NonCGIPath/digests/$DigestFile");
print TEMP "$ThisBody";
close(TEMP);
chmod (0666, "$NonCGIPath/digests/$DigestFile");
}

$message = $Body;

#process emails
foreach $sendto(@thislist) {
chomp($sendto);

$message .= "\n\rUm sich bei diesem Abo abzumelden, rufen Sie bitte folgende Seite auf: $CGIURL/ubbmail.cgi?action=subscribe";

if ($SMTPEmail eq "On") {
&SendEmail;
}  else {
&send_mail("$BBEmail", "$sendto", "$subject", "$message");
}
	$EmailLine .= "$sendto<BR>";
}

if ($EndLoop eq "true") {
&RecordDigestDate;
unlink ("$NonCGIPath/digests/$DigestFile");
$FinishWording = "Das Abo wurde erfolgreich an alle angemeldeten Nutzer gesendet.";
&FinishMail;
}  else {
&ContinueMail2;
}
}  #end SendTheDigest

sub RecordDigestDate {

@digestsummary = &GetDigestSummary;
@updated = @blank;

foreach $digester(@digestsummary) {
chomp($digester);
@digest = split(/\|/, $digester);
if ($digest[0] eq "$number") {
$LongDate = "$mday $ThisMonth $JSYear";
$revisedline = "$digest[0]|$LongDate|$TodayJules";
push(@updated, $revisedline);
}  else {
push(@updated, $digester);
}
}

&Lock("lock.file");
open(UPDATE, ">$NonCGIPath/digests/digestsummary.cgi");
foreach $iota(@updated) {
chomp($iota);
print UPDATE "$iota\n";
}
close(UPDATE);
&Unlock("lock.file");
}

sub ConvertMessage {
$message = shift;
$message =~ s/<p>/\n\r\n/isg;
$message =~ s/<br>/\n/isg;
$message =~ s/<IMG SRC="$NonCGIURL\/smile.gif">/:\)/isg;
$message =~ s/<IMG SRC="$NonCGIURL\/frown.gif">/:\(/isg;
$message =~ s/<IMG SRC="$NonCGIURL\/biggrin.gif">/\:D/isg;
$message =~ s/<IMG SRC="$NonCGIURL\/wink.gif">/\;\)/isg;
$message =~ s/<IMG SRC="$NonCGIURL\/redface.gif">/\:o/isg;
return($message);
}

sub ContinueMail2 {
print<<TheMail;
<HTML><HEAD>
<meta http-equiv="Refresh" content="2; URL=$CGIURL/ubbmail.cgi?action=sendthedigest&start=$StartHere&UserName=$UserNameCoded&Password=$PasswordCoded&Type=$in{'Type'}&TimeSpan=$in{'TimeSpan'}&ForumChoice=$number&DigestFile=$DigestFile">
</head>
<BODY bgcolor=#FFFFFF>
<center>
<FONT FACE="Verdana, Arial" SIZE="2"><B>
<FONT FACE="Courier New" SIZE="5" COLOR="Maroon"><B>System arbeitet .... bitte warten!</B></FONT>
<P>
Alle Abonnenten erhalten jetzt dieses Abo.
<P>
Benutzer <FONT FACE="Verdana" SIZE="3" COLOR="Navy">$StartDisplay</font> bis <FONT FACE="Verdana" SIZE="3" COLOR="Navy">$EndDisplay</font>...
<P></center>
Hier die Liste der Empf&auml;nger:
<P>
$EmailLine
</FONT>
</BODY>
</HTML>
TheMail

exit;
}

sub Unsubscribe {
my $number = $in{'digest'};
my $thisemail = $in{'email'};

@digestsummary = &GetDigestSummary;

DIGESTCHECK: foreach $digester(@digestsummary) {
@digest = split(/\|/, $digester);
if ($digest[1] eq "$number") {
	$DigestTitle = "$digest[0]";
	last DIGESTCHECK;
}

}
$thisemail = lc($thisemail);

open (EMAILLIST, "$NonCGIPath/digests/emaillist$number.cgi");
@theseemail = <EMAILLIST>;
close(EMAILLIST);

foreach $uno(@theseemail) {
	chomp($uno);
	unless ($uno eq "$thisemail") {
		push(@revised, $uno);
	}
}

&Lock("lock.file");
open (REVISED, ">$NonCGIPath/digests/emaillist$number.cgi");
foreach $one(@revised) {
print REVISED "$one\n";
}
close(REVISED);
&Unlock("lock.file");
&StandardHTML("Danke.  Wir haben Ihre eMail-Adresse aus folgendem Abo: $DigestTitle entfernt.<P>  Um unser Abo-Anmeldecenter zu besuchen, klicken Sie bitte <A HREF=\"$CGIURL/ubbmail.cgi?action=subscribe\">hier</a>.");
}

sub SubscribeListEmail {
@digsum = &GetDigestSummary;
$UserEmail = lc($in{'YourEmail'});
$MatchList = "";

foreach $one(@digsum) {
@thisdigest = split(/\|/, $one);
$digestnumber = $thisdigest[0];
@thisfor = &GetForumRecord($digestnumber);
$ForumName = $thisfor[1];
open(EMAIL, "$NonCGIPath/digests/emaillist$digestnumber.cgi");
@thismail = <EMAIL>;
close(EMAIL);

CHECKLIST: foreach $uno(@thismail) {
chomp($uno);
	if ($uno eq "$UserEmail") {

		$MatchList .= "$ForumName\n";
		last CHECKLIST;
	}
}
}

if ($MatchList eq "") {
	$MatchList = "Sie sind f&uuml;r keines unserer Abo's angemeldet.";
}

#send email--
$sendto = $UserEmail;
$subject = "Aktuelle Abo-Liste von $BBName";
$message = "Sie haben eine Liste mit den Abo's angefordert, f&uuml;r die Sie sich bei folgendem System angemeldet haben: $BBName ($CGIURL/Ultimate.cgi). \n\r\nLaut unserer Daten sind Sie f&uuml;r folgende Abo's angemeldet:\n\r\n$MatchList";

if ($SMTPEmail eq "On") {
&SendEmail;
}  else {
&send_mail("$BBEmail", "$sendto", "$subject", "$message");
}  

&StandardHTML("Wir haben Ihnen per e-Mail eine Liste mit den Abo's gesendet, f&uuml;r die Sie sich angemeldet haben.  Danke!<P><A HREF=\"$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true\">Zur&uuml;ck zu den Foren</A>");
}

sub SubscribeListIntro {
$PageTitle = "Abo - Center";
&DigestTopHTML2;

print<<MIDDLE;
<blockquote>
Um eine Liste mit den Abo's zu erhalten, f&uuml;r die Sie sich angemeldet haben, geben Sie bitte Ihre registrierte eMail-Adresse an.
</blockquote>
<FORM ACTION="$CGIURL/ubbmail.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="subscribelistemail">
<center>
Ihre eMail-Adresse: <INPUT TYPE="TEXT" NAME="YourEmail" SIZE=20 MAXLENGTH=90>
<P>
<INPUT TYPE="SUBMIT" NAME="Jetzt senden!">
</FORM>
</center>$Footer
</font>
</body></html>
MIDDLE

}  # end subscribelistntro


exit(0); # comply with SafePerl
